/*
** 2025 April 6
**
** The author disclaims copyright to this source code.  In place of a
** legal notice, here is a blessing:
**
**    May you do good and not evil.
**    May you find forgiveness for yourself and forgive others.
**    May you share freely, never taking more than you give.
*/

#include <tcl.h>
static int
Hello_Cmd(ClientData cdata, Tcl_Interp *interp, int objc, Tcl_Obj *const objv[]){
  Tcl_SetObjResult(interp, Tcl_NewStringObj("Hello, World!", -1));
  return TCL_OK;
}

#define stringy_(V) # V
#define stringy(V) stringy_(V)
extern int DLLEXPORT Hello_Init(Tcl_Interp *interp){
  if (Tcl_InitStubs(interp, TCL_VERSION, 0) == NULL) {
    return TCL_ERROR;
  }
  if (Tcl_PkgProvide(interp,
#if defined(TEAISH_PKGNAME)
                     stringy(TEAISH_PKGNAME),
#else
                      "hello",
#endif
#if defined(TEAISH_VERSION)
                     stringy(TEAISH_VERSION)
#else
                     "1.0"
#endif
      ) == TCL_ERROR) {
    return TCL_ERROR;
  }
  Tcl_CreateObjCommand(interp, "hello", Hello_Cmd, NULL, NULL);
  return TCL_OK;
}
#undef stringy
#undef stringy_
