if {1} {
  teaish-pkginfo-set \
    -name hello \
    -version 0.1 \
    -options {
      hello=1     => {Disable hello, world!}
    }
}
#teaish-pkginfo-set -vsatisfies 8.6-; # just for teaish testing

#teaish-pragma --have-own-pkgIndex.tcl

# Gets called by teaish-configure-core after bootstrapping is complete.
proc teaish-options {} {
  options-add {
    features=0  => {Enable teaish feature-test tests and new --flags}
  }
  # This ordering is important for the --help text
  if {[teaish-argv-has --features --enable-features]} {
    use teaish/feature-tests
    teaish-import-features -pre openssl
  }
  #options-add { hello=0 => {overridden} }; # just testing
  return {
    the-final-flag => {Just for demonstration's sake.}
  }
}

# Gets called by teaish-configure-core after processing of --flags.
proc teaish-configure {} {
  #proj-error just testing
  #proj-fatal just testing
  #teaish-enable-dist 0
  teaish-src-add -dir -dist hello.c

  if {[opt-bool features]} {
    define-push {TEAISH_LDFLAGS TEAISH_CFLAGS} {
      # These are just for testing teaish-feature-tests
      for {set i 0} {$i < 2} {incr i} {
        puts "******************** Feture tests..."
        foreach p {
          teaish-check-stdint
          teaish-check-libz
          teaish-check-librt
          teaish-check-dlopen
          teaish-check-libmath
        } {
          # Check that the caching works
          $p
        }
      }

      teaish-ldflags-prepend -lbar
      teaish-ldflags-add -prepend -lfoo
      teaish-ldflags-add -lbaz
      if {[teaish-is-mingw]} {
        teaish-cflags-add -DBROKEN_MINGW_CMDLINE
        teaish-ldflags-prepend -lkernel32 -lws2_32
      }

      msg-result "TEAISH_LDFLAGS = [get-define TEAISH_LDFLAGS]"
      msg-result "TEAISH_CFLAGS = [get-define TEAISH_CFLAGS]"
      msg-result "Clearing all of those flags, they were just for testing feature detection."
    }
  }; # testing of feature detection

  if {0} {
    apply {{} {
      set foo 3
      set argv {-a {hi world} -b -- -a {bye bye} -- -b c -- -a d}
      proj-parse-simple-flags argv flags {
        -a => "aaa"
        -b 0 {incr foo}
      }
      #parray flags;
      proj-assert {$flags(-a) eq "hi world"}
      proj-assert {$flags(-b) eq "4"}
      #puts "argv=$argv"

      teaish-pkginfo-get pi
      #parray pi
      proj-assert {[array size pi] > 6}
      proj-assert {"hello" eq [teaish-pkginfo-get -name]}
      set v [teaish-pkginfo-get]
      puts "teaish-pkginfo-get = {$v}"
      array set a $v
      parray a
    }}
  }; # random other testing

  teaish-define-to-cflag \
    TEAISH_PKGNAME TEAISH_VERSION

  #puts "*** [proj-define-to-cflag TEAISH_LIBDIR_NAME TEAISH_LOAD_PREFIX]"
  #puts "*** [proj-define-to-cflag -list TEAISH_LIBDIR_NAME TEAISH_LOAD_PREFIX]"
  #puts "??? real tcl? [info exists ::tcl_library] $::autosetup(istcl)"
  #parray ::tcl_platform

}
